<template>
  <el-row>
    <el-col :span="12" :offset="7" style="width: 100%">
      <h1>Todo List</h1>
      <todo-form @send-message="createTodo"></todo-form>
      <el-table :data="todos">
        <el-table-column prop="title" label="Title" width="350" />
        <!-- <el-table-column prop="completed" label="Completed" width="200" /> -->
        <el-table-column fixed="right" label="Operations" width="200">
          <template #default="scope">
            <el-space wrap>
              <el-switch
                v-model="scope.row.completed"
                @click="updateTodo(scpoe.row)"
              />
              <el-popconfirm 
                confirm-button-text="Yes" 
                cancel-button-text="No"
                icon="el-icon-info"
                icon-color="red"
                title="Are you sure to delete this Todo?"
                @confirm="handleDelete(scope.row)"
                @cancel="cancelDelete">
                <template #reference>
                  <el-button 
                  size="mini"
                  type="danger"
                  
                  >
                   Delete 
                  </el-button>
                </template>
              </el-popconfirm>
            </el-space>
          </template>
        </el-table-column>
      </el-table>
    </el-col>
  </el-row>
</template>

<script lang="ts">
import { ElMessage } from "element-plus";
import { Options, Vue } from "vue-class-component";
// import { axios } from "axios";
import TodoForm from "./TodoForm.vue";

interface Todo {
  id: number,
  title: string,
  completed: boolean
}
@Options({
  components: {
    TodoForm,
  },
})
export default class TodoList extends Vue {
  todos = [];

  async mounted() {
    await this.loadTodos();
  }

  async loadTodos() {
    const response = await this.axios.get("http://localhost:8080/todos");
    this.todos = response.data;
  }

  async createTodo(todo: Todo) {
    console.log("ToDo", todo);
    await this.axios.post("http://localhost:8080/todos", {
      title: todo.title,
      completed: todo.completed,
    });
    ElMessage({
      message: "Todo created successfully",
      type: "success",
    });
    await this.loadTodos();
  }
  async updateTodo(todo: Todo) {
    console.log("ToDo", todo);
    await this.axios.put('http://localhost:8080/todos/${todo.id}', {
      id: todo.id,
      title: todo.title,
      completed: todo.completed,
    });
    ElMessage({
      message: "Todo updated successfully",
      type: "success",
    });
    await this.loadTodos();
  }

  async handleDelete() {
    await this.axios.delete("http://localhost:8080/todos/${todo.id}");
    ElMessage({
      message: "Todo deleted successfully",
      type: "warning",
    });
    await this.loadTodos();
  }

  cancelDelete() {
    console.log("Delete action cancelled");
  }
}
</script>
